Index: LMDZ5/branches/testing/libf/phylmd/Dust/blcloud_scav_lsc.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/blcloud_scav_lsc.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/blcloud_scav_lsc.F	(revision 2641)
@@ -0,0 +1,125 @@
+c Subroutine that calculates the effect of precipitation in scavenging
+c BELOW the cloud, for large scale as well as convective precipitation
+      SUBROUTINE blcloud_scav_lsc(lminmax,qmin,qmax,pdtphys,prfl,psfl,
+     .                        pmflxr,pmflxs,zdz,alpha_r,alpha_s,masse,
+     .                                  his_dhbclsc,his_dhbccon,tr_seri)
+
+      USE dimphy
+      USE indice_sol_mod
+      USE infotrac
+      IMPLICIT NONE
+
+#include "dimensions.h"
+#include "chem.h"
+#include "YOMCST.h"
+#include "paramet.h"
+
+c============================= INPUT ===================================
+      REAL qmin,qmax
+      REAL pdtphys  ! pas d'integration pour la physique (seconde)
+!      REAL prfl(klon,klev),   psfl(klon,klev)     !--large-scale
+!      REAL pmflxr(klon,klev), pmflxs(klon,klev)   !--convection
+      REAL alpha_r(nbtr)!--coefficient d'impaction pour la pluie
+      REAL alpha_s(nbtr)!--coefficient d'impaction pour la neige      
+      REAL masse(nbtr)
+      LOGICAL lminmax
+      REAL zdz(klon,klev)
+      REAL prfl(klon,klev+1),   psfl(klon,klev+1)     !--large-scale  ! Titane
+      REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)   !--convection   ! Titane
+c============================= OUTPUT ==================================
+      REAL tr_seri(klon,klev,nbtr) ! traceur
+      REAL aux_var1(klon,klev) ! traceur
+      REAL aux_var2(klon,klev) ! traceur
+      REAL his_dhbclsc(klon,nbtr), his_dhbccon(klon,nbtr)
+c========================= LOCAL VARIABLES =============================      
+      INTEGER it, k, i, j
+      REAL d_tr(klon,klev,nbtr)
+
+      EXTERNAL minmaxqfi, bcscav_spl
+      
+      DO it=1, nbtr
+c
+      DO j=1,klev
+      DO i=1,klon
+        aux_var1(i,j)=tr_seri(i,j,it)
+        aux_var2(i,j)=d_tr(i,j,it)
+      ENDDO
+      ENDDO
+c
+cnhl      CALL bcscav_spl(pdtphys,prfl,psfl,alpha_r(it),alpha_s(it),
+cnhl     .                tr_seri(1,1,it),d_tr(1,1,it))
+      CALL bcscav_spl(pdtphys,prfl,psfl,alpha_r(it),alpha_s(it),
+     .                aux_var1,aux_var2)
+c
+      DO j=1,klev
+      DO i=1,klon
+        tr_seri(i,j,it)=aux_var1(i,j)
+        d_tr(i,j,it)=aux_var2(i,j)
+      ENDDO
+      ENDDO
+      DO k = 1, klev
+      DO i = 1, klon
+         tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr(i,k,it)
+         his_dhbclsc(i,it)=his_dhbclsc(i,it)-d_tr(i,k,it)/RNAVO*
+     .                masse(it)*1.e3*1.e6*zdz(i,k)/pdtphys  !--mgS/m2/s
+              
+      ENDDO
+      ENDDO
+c
+      DO i=1,klon
+      DO j=1,klev
+        aux_var1(i,j)=tr_seri(i,j,it)
+        aux_var2(i,j)=d_tr(i,j,it)
+      ENDDO
+      ENDDO
+c
+      IF (lminmax) THEN
+        CALL minmaxqfi(aux_var1,qmin,qmax,'depot humide bc lsc')
+cnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'depot humide bc lsc')
+      ENDIF
+c
+c-scheme for convective scavenging
+c
+cnhl      CALL bcscav_spl(pdtphys,pmflxr,pmflxs,alpha_r(it),alpha_s(it),
+cnhl     .                tr_seri(1,1,it),d_tr(1,1,it))
+
+
+cJE      CALL bcscav_spl(pdtphys,pmflxr,pmflxs,alpha_r(it),alpha_s(it),
+cJE     .                aux_var1,aux_var2)
+
+
+c
+      DO i=1,klon
+      DO j=1,klev
+        tr_seri(i,j,it)=aux_var1(i,j)
+        d_tr(i,j,it)=aux_var2(i,j)
+      ENDDO
+      ENDDO
+c
+      DO k = 1, klev
+      DO i = 1, klon
+         tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr(i,k,it)
+         his_dhbccon(i,it)=his_dhbccon(i,it)-d_tr(i,k,it)/RNAVO*
+     .                masse(it)*1.e3*1.e6*zdz(i,k)/pdtphys    !--mgS/m2/s
+      ENDDO
+      ENDDO
+c
+      IF (lminmax) THEN
+        DO j=1,klev
+        DO i=1,klon
+          aux_var1(i,j)=tr_seri(i,j,it)
+        ENDDO
+        ENDDO
+        CALL minmaxqfi(aux_var1,qmin,qmax,'depot humide bc con')
+cnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'depot humide bc con')
+        DO j=1,klev
+        DO i=1,klon
+          tr_seri(i,j,it)=aux_var1(i,j)
+        ENDDO
+        ENDDO
+      ENDIF
+c
+c
+      ENDDO !--boucle sur it
+c
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/checkmass.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/checkmass.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/checkmass.F90	(revision 2641)
@@ -0,0 +1,59 @@
+SUBROUTINE checkmass(zq,RNAVOG,mass,zdz,pplay,t_seri,iscm3,comment)
+  USE dimphy
+USE geometry_mod , ONLY:cell_area
+  IMPLICIT NONE
+
+#include "YOMCST.h"
+
+! Entrees
+  REAL,DIMENSION(klon,klev), INTENT(IN)   :: zq
+  REAL,DIMENSION(klon,klev), INTENT(IN)   :: zdz
+  REAL,INTENT(IN)                         :: mass
+  REAL,INTENT(IN)                         :: RNAVOG
+  CHARACTER(LEN=*),INTENT(IN)             :: comment
+REAL,DIMENSION(klon,klev) ,INTENT(IN)  :: pplay
+REAL,DIMENSION(klon,klev) ,INTENT(IN) :: t_seri
+LOGICAL :: iscm3
+
+
+! Local  
+!  INTEGER,DIMENSION(klon)     :: jadrs
+  INTEGER                     :: i, k
+  REAL                              :: totmass
+  REAL,DIMENSION(klon)              ::  burden
+  REAL,DIMENSION(klon,klev)   :: zqv
+
+
+DO i=1, klon
+burden(i)=0.0
+  DO k=1, klev
+zqv(i,k)=zq(i,k)
+
+ENDDO
+
+ENDDO
+
+totmass=0.0
+
+
+IF (iscm3) THEN
+
+ELSE
+
+CALL kg_to_cm3(pplay,t_seri,zqv)
+
+ENDIF
+
+  DO k=1, klev
+      DO i=1, klon
+        burden(i)=burden(i)+(zqv(i,k)*1.e6*zdz(i,k)* &
+                 mass*1.e3/RNAVOG)     !--mg S/m2
+    ENDDO
+  ENDDO
+    DO i=1, klon
+        totmass=totmass+burden(i)*cell_area(i)
+ENDDO
+WRITE(*,9999) comment," totmass= ",totmass
+9999  format(a20,a10,e15.8)
+
+END SUBROUTINE checkmass
Index: LMDZ5/branches/testing/libf/phylmd/Dust/checknanqfi.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/checknanqfi.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/checknanqfi.F90	(revision 2641)
@@ -0,0 +1,32 @@
+SUBROUTINE checknanqfi(zq,qmin,qmax,comment)
+  USE dimphy
+  IMPLICIT NONE
+
+! Entrees
+  REAL,DIMENSION(klon,klev), INTENT(IN)   :: zq
+  REAL,INTENT(IN)                         :: qmin,qmax
+  CHARACTER(LEN=*),INTENT(IN)             :: comment
+
+! Local  
+  INTEGER,DIMENSION(klon)     :: jadrs 
+  INTEGER                     :: i, jbad, k
+  
+  DO k = 1, klev
+     jbad = 0
+     DO i = 1, klon
+!        IF (zq(i,k).GT.qmax .OR. zq(i,k).LT.qmin) THEN
+        IF (isnan(zq(i,k))) THEN
+           jbad = jbad + 1
+           jadrs(jbad) = i
+        ENDIF
+     ENDDO
+     IF (jbad.GT.0) THEN
+        WRITE(*,*)comment
+        DO i = 1, jbad
+           WRITE(*,*) "i,k,q=", jadrs(i),k,zq(jadrs(i),k)
+           CALL abort_gcm(comment, 'NaN founded',1)
+        ENDDO
+     ENDIF
+  ENDDO
+  
+END SUBROUTINE checknanqfi
Index: LMDZ5/branches/testing/libf/phylmd/Dust/chem_spla.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/chem_spla.h	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/chem_spla.h	(revision 2641)
@@ -0,0 +1,14 @@
+!
+! $Header$
+!
+
+      INTEGER ss_bins
+      PARAMETER (ss_bins=2)
+
+!      INTEGER nbreg_dust,nbreg_ind, nbreg_bb
+!      PARAMETER (nbreg_dust=11,nbreg_ind=13,nbreg_bb=15)
+
+      REAL masse_ammsulfate
+      PARAMETER (masse_ammsulfate=132.0)              !--g mol-1
+
+
Index: LMDZ5/branches/testing/libf/phylmd/Dust/cltrac_spl.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/cltrac_spl.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/cltrac_spl.F	(revision 2641)
@@ -0,0 +1,137 @@
+      SUBROUTINE cltrac_spl(dtime,coef,yu1,yv1,t,tr,
+     .                     flux,paprs,pplay,d_tr)
+
+      USE dimphy
+      IMPLICIT none
+c======================================================================
+c Auteur(s): O. Boucher (LOA/LMD) date: 19961127
+c            inspire de clvent
+c Objet: diffusion verticale de traceurs avec flux fixe a la surface
+c        ou/et flux du type c-drag
+c======================================================================
+c Arguments:
+c dtime----input-R- intervalle du temps (en second)
+c coef-----input-R- le coefficient d'echange (m**2/s) l>1
+c yu1------input-R- le vent dans le 1iere couche
+c yv1------input-R- le vent dans le 1iere couche
+c t--------input-R- temperature (K)
+c tr-------input-R- la q. de traceurs
+c flux-----input-R- le flux de traceurs a la surface
+c paprs----input-R- pression a inter-couche (Pa)
+c pplay----input-R- pression au milieu de couche (Pa)
+c delp-----input-R- epaisseur de couche (Pa)
+c cdrag----input-R- cdrag pour le flux de surface (non active)
+c tr0------input-R- traceurs a la surface ou dans l'ocean (non active)
+c d_tr-----output-R- le changement de tr
+c flux_tr--output-R- flux de tr
+c======================================================================
+#include "dimensions.h"
+      REAL dtime
+      REAL coef(klon,klev)
+      REAL yu1(klon), yv1(klon)
+      REAL t(klon,klev), tr(klon,klev)
+      REAL paprs(klon,klev+1), pplay(klon,klev), delp(klon,klev)
+      REAL d_tr(klon,klev)
+      REAL flux(klon), cdrag(klon), tr0(klon)
+c      REAL flux_tr(klon,klev)
+c======================================================================
+#include "YOMCST.h"
+c======================================================================
+      INTEGER i, k
+      REAL zx_ctr(klon,2:klev)
+      REAL zx_dtr(klon,2:klev)
+      REAL zx_buf(klon)
+      REAL zx_coef(klon,klev)
+      REAL local_tr(klon,klev)
+      REAL zx_alf1(klon), zx_alf2(klon), zx_flux(klon)
+c======================================================================
+c CHECKING VALUES
+!      print *,'CHECKING VALUES IN CLTRAC (INI)'
+!      print *,'d_tr = ',sum(d_tr),MINVAL(d_tr),MAXVAL(d_tr)
+!      print *,'flux = ',sum(flux),MINVAL(flux),MAXVAL(flux)
+!      print *,'tr = ',sum(tr),MINVAL(tr),MAXVAL(tr)
+c======================================================================
+      DO k = 1, klev
+      DO i = 1, klon
+         local_tr(i,k) = tr(i,k)
+         delp(i,k) = paprs(i,k)-paprs(i,k+1)
+      ENDDO
+      ENDDO
+c======================================================================
+      DO i = 1, klon
+         zx_alf1(i) = (paprs(i,1)-pplay(i,2))/(pplay(i,1)-pplay(i,2))
+         zx_alf2(i) = 1.0 - zx_alf1(i)
+         zx_flux(i) =  -flux(i)*dtime*RG
+c--pour le moment le flux est prescrit
+         cdrag(i) = 0.0 
+c         cdrag(i) =  coef(i,1) * (1.0+SQRT(yu1(i)**2+yv1(i)**2))
+c     .                * pplay(i,1)/(RD*t(i,1))
+         tr0(i) = 0.0
+         zx_coef(i,1) = cdrag(i)*dtime*RG 
+      ENDDO
+c======================================================================
+      DO k = 2, klev
+      DO i = 1, klon
+         zx_coef(i,k) = coef(i,k)*RG/(pplay(i,k-1)-pplay(i,k))
+     .                  *(paprs(i,k)*2/(t(i,k)+t(i,k-1))/RD)**2
+         zx_coef(i,k) = zx_coef(i,k)*dtime*RG
+      ENDDO
+      ENDDO
+c======================================================================
+      DO i = 1, klon
+         zx_buf(i) = delp(i,1) + zx_coef(i,1)*zx_alf1(i) + zx_coef(i,2)
+         zx_ctr(i,2) = (local_tr(i,1)*delp(i,1)+
+     .                  zx_coef(i,1)*tr0(i)-zx_flux(i))/zx_buf(i)
+         zx_dtr(i,2) = (zx_coef(i,2)-zx_alf2(i)*zx_coef(i,1)) / 
+     .                  zx_buf(i)
+      ENDDO
+c
+      DO k = 3, klev
+      DO i = 1, klon
+         zx_buf(i) = delp(i,k-1) + zx_coef(i,k)
+     .                  + zx_coef(i,k-1)*(1.-zx_dtr(i,k-1))
+         zx_ctr(i,k) = (local_tr(i,k-1)*delp(i,k-1)
+     .                  +zx_coef(i,k-1)*zx_ctr(i,k-1) )/zx_buf(i)
+         zx_dtr(i,k) = zx_coef(i,k)/zx_buf(i)
+      ENDDO
+      ENDDO
+      DO i = 1, klon
+         local_tr(i,klev) = ( local_tr(i,klev)*delp(i,klev)
+     .                        +zx_coef(i,klev)*zx_ctr(i,klev) )
+     .                   / ( delp(i,klev) + zx_coef(i,klev)
+     .                       -zx_coef(i,klev)*zx_dtr(i,klev) )
+      ENDDO
+      DO k = klev-1, 1, -1
+      DO i = 1, klon
+         local_tr(i,k) = zx_ctr(i,k+1) + zx_dtr(i,k+1)*local_tr(i,k+1)
+      ENDDO
+      ENDDO
+c======================================================================
+!      print *,'CHECKING VALUES IN CLTRAC (FIN)'
+!      print *,'local_tr = ',sum(local_tr),MINVAL(local_tr),
+!     .                                    MAXVAL(local_tr)
+!      print *,'zx_ctr = ',sum(zx_ctr),MINVAL(zx_ctr),MAXVAL(zx_ctr)
+!      print *,'zx_dtr = ',sum(zx_dtr),MINVAL(zx_dtr),MAXVAL(zx_dtr)
+!      print *,'tr = ',sum(tr),MINVAL(tr),MAXVAL(tr)
+c======================================================================
+c== flux_tr est le flux de traceur (positif vers bas)
+c      DO i = 1, klon
+c         flux_tr(i,1) = zx_coef(i,1)/(RG*dtime)
+c      ENDDO
+c      DO k = 2, klev
+c      DO i = 1, klon
+c         flux_tr(i,k) = zx_coef(i,k)/(RG*dtime)
+c     .               * (local_tr(i,k)-local_tr(i,k-1))
+c      ENDDO
+c      ENDDO
+c======================================================================
+      DO k = 1, klev
+      DO i = 1, klon
+         d_tr(i,k) = local_tr(i,k) - tr(i,k)
+      ENDDO
+      ENDDO
+!      print *,'CHECKING VALUES IN CLTRAC (END)'
+!      print *,'d_tr = ',sum(d_tr),MINVAL(d_tr),MAXVAL(d_tr)
+c
+      RETURN
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/cm3_to_kg.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/cm3_to_kg.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/cm3_to_kg.F	(revision 2641)
@@ -0,0 +1,25 @@
+      SUBROUTINE cm3_to_kg(pplay,t_seri,tr_seri)
+
+      USE dimphy
+      USE infotrac
+      USE indice_sol_mod
+
+      IMPLICIT NONE
+c
+#include "dimensions.h"
+#include "YOMCST.h"
+c      
+      REAL t_seri(klon,klev), pplay(klon,klev)
+      REAL tr_seri(klon,klev)
+      REAL zrho
+      INTEGER i, k
+c
+!JE20150707      RD = 1000.0 * 1.380658E-23 * 6.0221367E+23 / 28.9644
+      DO k = 1, klev
+      DO i = 1, klon
+        zrho=pplay(i,k)/t_seri(i,k)/RD
+        tr_seri(i,k)=tr_seri(i,k)*1.e6/zrho
+      ENDDO
+      ENDDO
+c 
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/coarsemission.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/coarsemission.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/coarsemission.F	(revision 2641)
@@ -0,0 +1,313 @@
+c This subroutine calculates the emissions of SEA SALT and DUST, part of
+C which goes to tracer 2 and other part to tracer 3.
+      SUBROUTINE coarsemission(pctsrf,pdtphys,
+     .                         t_seri,pmflxr,pmflxs,prfl,psfl,
+     .                         xlat,xlon,debutphy,
+     .                         zu10m,zv10m,wstar,ale_bl,ale_wake,
+     .                         scale_param_ssacc,scale_param_sscoa,
+     .                         scale_param_dustacc,scale_param_dustcoa,
+     .                         scale_param_dustsco,
+     .                         nbreg_dust,
+     .                         iregion_dust,dust_ec,
+     .                  param_wstarBLperregion,param_wstarWAKEperregion,
+     .                  nbreg_wstardust,
+     .                  iregion_wstardust,
+     .                         lmt_sea_salt,qmin,qmax,
+     .                             flux_sparam_ddfine,flux_sparam_ddcoa,
+     .                             flux_sparam_ddsco,
+     .                             flux_sparam_ssfine,flux_sparam_sscoa,
+     .                          id_prec,id_fine,id_coss,id_codu,id_scdu,
+     .                          ok_chimeredust,
+     .                                                source_tr,flux_tr)
+!     .                         wth,cly,zprecipinsoil,lmt_sea_salt,
+
+!      CALL dustemission( debutphy, xlat, xlon, pctsrf, 
+!     .               zu10m     zv10m,wstar,ale_bl,ale_wake)
+!
+
+      USE dimphy
+      USE indice_sol_mod
+      USE infotrac
+      USE dustemission_mod,  ONLY : dustemission 
+!      USE phytracr_spl_mod, ONLY : nbreg_dust, nbreg_ind, nbreg_bb
+      IMPLICIT NONE
+
+#include "dimensions.h"
+#include "chem.h"
+#include "chem_spla.h"
+#include "YOMCST.h"
+#include "paramet.h"
+      
+c============================== INPUT ==================================
+      INTEGER nbjour
+      LOGICAL ok_chimeredust
+      REAL pdtphys  ! pas d'integration pour la physique (seconde)
+      REAL t_seri(klon,klev)  ! temperature
+      REAL pctsrf(klon,nbsrf)
+      REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)   !--convection
+!      REAL pmflxr(klon,klev), pmflxs(klon,klev)   !--convection
+      REAL prfl(klon,klev+1),   psfl(klon,klev+1)     !--large-scale
+!      REAL prfl(klon,klev),   psfl(klon,klev)     !--large-scale
+      LOGICAL debutphy, lafinphy
+      REAL, intent(in) ::  xlat(klon)    ! latitudes pour chaque point 
+      REAL, intent(in) ::  xlon(klon)    ! longitudes pour chaque point 
+      REAL,DIMENSION(klon),INTENT(IN)    :: zu10m
+      REAL,DIMENSION(klon),INTENT(IN)    :: zv10m
+      REAL,DIMENSION(klon),INTENT(IN)    :: wstar,Ale_bl,ale_wake
+
+c
+c------------------------- Scaling Parameters --------------------------
+c
+      INTEGER iregion_dust(klon) !Defines  dust regions
+      REAL scale_param_ssacc  !Scaling parameter for Fine Sea Salt
+      REAL scale_param_sscoa  !Scaling parameter for Coarse Sea Salt
+      REAL scale_param_dustacc(nbreg_dust)  !Scaling parameter for Fine Dust
+      REAL scale_param_dustcoa(nbreg_dust)  !Scaling parameter for Coarse Dust
+      REAL scale_param_dustsco(nbreg_dust)  !Scaling parameter for SCoarse Dust
+!JE20141124<<
+      INTEGER iregion_wstardust(klon) !Defines dust regions in terms of wstar
+      REAL param_wstarBLperregion(nbreg_wstardust)  !
+      REAL param_wstarWAKEperregion(nbreg_wstardust)  !
+      REAL param_wstarBL(klon)  !parameter for surface wind correction..
+      REAL param_wstarWAKE(klon)  !parameter for surface wind correction..
+      INTEGER  nbreg_wstardust
+!JE20141124>>
+      INTEGER  nbreg_dust
+      INTEGER, INTENT(IN) :: id_prec,id_fine,id_coss,id_codu,id_scdu
+c============================== OUTPUT =================================
+      REAL source_tr(klon,nbtr)
+      REAL flux_tr(klon,nbtr)
+      REAL flux_sparam_ddfine(klon), flux_sparam_ddcoa(klon)
+      REAL flux_sparam_ddsco(klon)
+      REAL flux_sparam_ssfine(klon), flux_sparam_sscoa(klon)
+c=========================== LOCAL VARIABLES ===========================            
+      INTEGER i, j
+      REAL pct_ocean(klon)
+!      REAL zprecipinsoil(klon)
+!      REAL cly(klon), wth(klon)
+      REAL clyfac, avgdryrate, drying
+            
+c---------------------------- SEA SALT emissions ------------------------
+      REAL lmt_sea_salt(klon,ss_bins) !Sea salt 0.03-8.0 um                         
+c
+c--------vent 10 m CEPMMT
+c
+      REAL dust_ec(klon)
+
+      real tmp_var2(klon,nbtr) ! auxiliary variable to replace source
+      REAL qmin, qmax
+!----------------------DUST Sahara ---------------
+      REAL, DIMENSION(klon) :: dustsourceacc,dustsourcecoa,dustsourcesco
+      INTEGER, DIMENSION(klon) :: maskd
+C*********************** DUST EMMISSIONS *******************************
+c
+      
+!     avgdryrate=300./365.*pdtphys/86400.
+c
+!     DO i=1, klon
+c
+!       IF (cly(i).LT.9990..AND.wth(i).LT.9990.) THEN
+!        zprecipinsoil(i)=zprecipinsoil(i) +
+!    .        (pmflxr(i,1)+pmflxs(i,1)+prfl(i,1)+psfl(i,1))*pdtphys
+c
+!        clyfac=MIN(16., cly(i)*0.4+8.) ![mm] max amount of water hold in top soil
+!        drying=avgdryrate*exp(0.03905491*
+!    .                    exp(0.17446*(t_seri(i,1)-273.15))) ! [mm]
+!        zprecipinsoil(i)=min(max(0.,zprecipinsoil(i)-drying),clyfac) ! [mm]
+c         
+!       ENDIF
+c
+!     ENDDO
+c                
+c ==================== CALCULATING DUST EMISSIONS ======================
+c
+!      IF (lminmax) THEN
+      DO j=1,nbtr
+      DO i=1,klon
+         tmp_var2(i,j)=source_tr(i,j)
+      ENDDO
+      ENDDO
+      CALL minmaxsource(tmp_var2,qmin,qmax,'src: before DD emiss')
+!      print *,'Source = ',SUM(source_tr),MINVAL(source_tr),
+!     .                                     MAXVAL(source_tr)
+!      ENDIF
+
+c
+      IF (.NOT. ok_chimeredust)  THEN  
+      DO i=1, klon
+!!     IF (cly(i).GE.9990..OR.wth(i).GE.9990..OR.
+!!    .    t_seri(i,1).LE.273.15.OR.zprecipinsoil(i).GT.1.e-8) THEN
+!!          dust_ec(i)=0.0
+!!     ENDIF
+!c Corresponds to dust_emission.EQ.3        
+!!!!!!!****************AQUIIIIIIIIIIIIIIIIIIIIIIIIIIII
+!! Original line (4 tracers)
+!JE<<  old 4 tracer(nhl scheme)        source_tr(i,id_fine)=scale_param_dustacc(iregion_dust(i))*
+!     .                  dust_ec(i)*1.e3*0.093   ! g/m2/s
+!         source_tr(i,id_codu)=scale_param_dustcoa(iregion_dust(i))*
+!     .                  dust_ec(i)*1.e3*0.905   ! g/m2/s   bin 0.5-10um
+!! Original line (4 tracers)
+!         flux_tr(i,id_fine)=scale_param_dustacc(iregion_dust(i))*
+!     .                  dust_ec(i)*1.e3*0.093*1.e3  !mg/m2/s
+!         flux_tr(i,id_codu)=scale_param_dustcoa(iregion_dust(i))*
+!     .                  dust_ec(i)*1.e3*0.905*1.e3  !mg/m2/s bin 0.5-10um
+!         flux_sparam_ddfine(i)=scale_param_dustacc(iregion_dust(i)) *
+!     .                            dust_ec(i)*1.e3*0.093*1.e3
+!         flux_sparam_ddcoa(i)=scale_param_dustcoa(iregion_dust(i)) *
+!     .                            dust_ec(i)*1.e3*0.905*1.e3
+      IF(id_fine>0)     source_tr(i,id_fine)=
+     . scale_param_dustacc(iregion_dust(i))*
+     .                  dust_ec(i)*1.e3*0.093   ! g/m2/s 
+      IF(id_codu>0)   source_tr(i,id_codu)=
+     . scale_param_dustcoa(iregion_dust(i))*
+     .                  dust_ec(i)*1.e3*0.905   ! g/m2/s   bin 0.5-10um
+      IF(id_scdu>0)  source_tr(i,id_scdu)=0.   ! no supercoarse
+! Original line (4 tracers)
+       IF(id_fine>0)   flux_tr(i,id_fine)=
+     .  scale_param_dustacc(iregion_dust(i))*
+     .                  dust_ec(i)*1.e3*0.093*1.e3  !mg/m2/s
+       IF(id_codu>0)  flux_tr(i,id_codu)=
+     . scale_param_dustcoa(iregion_dust(i))*
+     .                  dust_ec(i)*1.e3*0.905*1.e3  !mg/m2/s bin 0.5-10um
+       IF(id_scdu>0) flux_tr(i,id_scdu)=0.
+
+         flux_sparam_ddfine(i)=scale_param_dustacc(iregion_dust(i)) *
+     .                            dust_ec(i)*1.e3*0.093*1.e3
+         flux_sparam_ddcoa(i)=scale_param_dustcoa(iregion_dust(i)) *
+     .                            dust_ec(i)*1.e3*0.905*1.e3
+         flux_sparam_ddsco(i)=0.
+      ENDDO
+      ENDIF
+!*****************NEW CHIMERE DUST EMISSION Sahara*****
+! je  20140522
+      IF(ok_chimeredust) THEN
+      print *,'MIX- NEW SAHARA DUST SOURCE SCHEME...'
+
+      DO i=1,klon
+      param_wstarBL(i)  =param_wstarBLperregion(iregion_wstardust(i))
+      param_wstarWAKE(i)=param_wstarWAKEperregion(iregion_wstardust(i))
+      ENDDO
+
+
+      CALL dustemission( debutphy, xlat, xlon, pctsrf,
+     .                  zu10m,zv10m,wstar,ale_bl,ale_wake,
+     .                  param_wstarBL, param_wstarWAKE,
+     .                  dustsourceacc,dustsourcecoa,
+     .                  dustsourcesco,maskd)
+      
+      DO i=1,klon   
+         if (maskd(i).gt.0) then 
+      IF(id_fine>0)    source_tr(i,id_fine)=
+     . scale_param_dustacc(iregion_dust(i))*
+     .                  dustsourceacc(i)*1.e3   ! g/m2/s  bin 0.03-0.5
+      IF(id_codu>0)    source_tr(i,id_codu)=
+     . scale_param_dustcoa(iregion_dust(i))*
+     .                  dustsourcecoa(i)*1.e3   ! g/m2/s   bin 0.5-3um
+      IF(id_scdu>0)   source_tr(i,id_scdu)=
+     . scale_param_dustsco(iregion_dust(i))*
+     .                  dustsourcesco(i)*1.e3   ! g/m2/s   bin 3-15um
+! Original line (4 tracers)
+       IF(id_fine>0)  flux_tr(i,id_fine)=
+     .  scale_param_dustacc(iregion_dust(i))*
+     .                  dustsourceacc(i)*1.e3*1.e3  !mg/m2/s
+       IF(id_codu>0)  flux_tr(i,id_codu)=
+     . scale_param_dustcoa(iregion_dust(i))*
+     .                  dustsourcecoa(i)*1.e3*1.e3  !mg/m2/s bin 0.5-3um
+       IF(id_scdu>0)  flux_tr(i,id_scdu)=
+     . scale_param_dustsco(iregion_dust(i))*
+     .                  dustsourcesco(i)*1.e3*1.e3  !mg/m2/s bin 3-15um
+         flux_sparam_ddfine(i)=scale_param_dustacc(iregion_dust(i)) *
+     .                            dustsourceacc(i)*1.e3*1.e3
+         flux_sparam_ddcoa(i)=scale_param_dustcoa(iregion_dust(i)) *
+     .                            dustsourcecoa(i)*1.e3*1.e3
+         flux_sparam_ddsco(i)=scale_param_dustsco(iregion_dust(i)) *
+     .                            dustsourcesco(i)*1.e3*1.e3
+         else
+        IF(id_fine>0) source_tr(i,id_fine)=
+     .  scale_param_dustacc(iregion_dust(i))*
+     .                  dust_ec(i)*1.e3*0.114   ! g/m2/s
+        IF(id_codu>0) source_tr(i,id_codu)=
+     .  scale_param_dustcoa(iregion_dust(i))*
+     .                  dust_ec(i)*1.e3*0.108   ! g/m2/s   bin 0.5-3um
+        IF(id_scdu>0) source_tr(i,id_scdu)=
+     .  scale_param_dustsco(iregion_dust(i))*
+     .                  dust_ec(i)*1.e3*0.778   ! g/m2/s   bin 3-15um
+! Original line (4 tracers)
+        IF(id_fine>0) flux_tr(i,id_fine)=
+     . scale_param_dustacc(iregion_dust(i))*
+     .                  dust_ec(i)*1.e3*0.114*1.e3  !mg/m2/s
+        IF(id_codu>0) flux_tr(i,id_codu)=
+     . scale_param_dustcoa(iregion_dust(i))*
+     .                  dust_ec(i)*1.e3*0.108*1.e3  !mg/m2/s bin 0.5-3um
+        IF(id_scdu>0) flux_tr(i,id_scdu)=
+     . scale_param_dustsco(iregion_dust(i))*
+     .                  dust_ec(i)*1.e3*0.778*1.e3  !mg/m2/s bin 0.5-3um
+
+         flux_sparam_ddfine(i)=scale_param_dustacc(iregion_dust(i)) *
+     .                            dust_ec(i)*1.e3*0.114*1.e3
+         flux_sparam_ddcoa(i)=scale_param_dustcoa(iregion_dust(i)) *
+     .                            dust_ec(i)*1.e3*0.108*1.e3
+         flux_sparam_ddsco(i)=scale_param_dustsco(iregion_dust(i)) *
+     .                            dust_ec(i)*1.e3*0.778*1.e3
+
+         endif
+      ENDDO
+
+
+
+
+
+      ENDIF
+!*****************************************************                                   
+C******************* SEA SALT EMMISSIONS *******************************
+      DO i=1,klon
+         pct_ocean(i)=pctsrf(i,is_oce)
+      ENDDO
+c
+!      IF (lminmax) THEN
+      DO j=1,nbtr
+      DO i=1,klon
+         tmp_var2(i,j)=source_tr(i,j)
+      ENDDO
+      ENDDO
+      CALL minmaxsource(tmp_var2,qmin,qmax,'src: before SS emiss')
+      IF(id_coss>0) then
+      print *,'Source = ',SUM(source_tr(:,id_coss)),
+     .     MINVAL(source_tr(:,id_coss)), MAXVAL(source_tr(:,id_coss))
+      ENDIF
+!
+      DO i=1,klon
+! Original line (4 tracers)
+         IF(id_fine>0) source_tr(i,id_fine)=
+     . source_tr(i,id_fine)+scale_param_ssacc*
+     .                                 lmt_sea_salt(i,1)*1.e4       !g/m2/s
+
+! Original line (4 tracers)
+       IF(id_fine>0)  flux_tr(i,id_fine)=
+     . flux_tr(i,id_fine)+scale_param_ssacc
+     .                            *lmt_sea_salt(i,1)*1.e4*1.e3      !mg/m2/s
+!
+      IF(id_coss>0)  source_tr(i,id_coss)=
+     . scale_param_sscoa*lmt_sea_salt(i,2)*1.e4    !g/m2/s
+      IF(id_coss>0)  flux_tr(i,id_coss)=
+     . scale_param_sscoa*lmt_sea_salt(i,2)*1.e4*1.e3 !mg/m2/s
+c
+         flux_sparam_ssfine(i)=scale_param_ssacc *
+     .                                  lmt_sea_salt(i,1)*1.e4*1.e3
+         flux_sparam_sscoa(i)=scale_param_sscoa *
+     .                                  lmt_sea_salt(i,2)*1.e4*1.e3
+      ENDDO
+!      IF (lminmax) THEN
+      DO j=1,nbtr
+      DO i=1,klon
+         tmp_var2(i,j)=source_tr(i,j)
+      ENDDO
+      ENDDO
+      CALL minmaxsource(tmp_var2,qmin,qmax,'src: after SS emiss')
+      IF(id_coss>0) then
+      print *,'Source = ',SUM(source_tr(:,id_coss)),
+     .  MINVAL(source_tr(:,id_coss)), MAXVAL(source_tr(:,id_coss))
+      ENDIF
+c     
+
+      END
